10 'GR8BUS master Micro-SD browsing and
20 'file download program (FAT32)
30 'Copyleft 2013 Eugeny Brychkov
40 'Please refer to license supplied
50 'with this software
60 '--------------------------------
70 'IMPORTANT: uses 32-bit mathematics in software emulated floating point mode
80 CLEAR 512,(PEEK(&HFC4A)+PEEK(&HFC4B)*256)-&H180:'reserving space for assembly code
90 MA=PEEK(&HFC4A)+PEEK(&HFC4B)*256:'base address for asm
100 PRINT"Micro-SD reader program for GR8BIT"
110 PRINT"Copyleft (cl) 2013 Eugeny Brychkov":PRINT
120 PRINT"Preparing to launch..."
130 DIM DC(128):'directory/file cluster chain; DC=chain length
140 DIM DN$(32):'directory names in hierarchy
150 DIM DH(32):'directory hierarchy of starting clusters, DD=directory depth (0=root)
160 H=PEEK(&HF34D)+PEEK(&HF34E)*256:'512 byte Buffer address
170 GOSUB 1890:'Poke ASM inline subroutines
180 OUT&HAC,6:'SCLK idle low
190 PRINT"Insert a card, press any key":A$=INPUT$(1)
200 ' ### providing 75 clocks ###
210 PRINT"Providing 75 clocks":U=USR4(0)
220 ' ### sending CMD0 ###
230 PRINT"Initializing card"
240 C$="4000000000":GOSUB 1700:U=USR6(0):U=USR1(0):GOSUB 1650
250 IF S=1 THEN PRINT"  > SPI mode initiated" ELSE PRINT"  > SPI mode failed":STOP
260 ' ### sending CMD8 to identify HC card ###
270 C$="48000001AA":GOSUB 1700:U=USR6(0):U=USR1(0):GOSUB 1670
280 A=PEEK(MA+6):IF (A AND 4)=4 THEN PRINT"  > SDCV1 detected":GOTO 310
290 PRINT"  > SDCV2 detected":
300 L=4:POKE MA+8,(L AND &HFF):POKE MA+9,L/256:U=USR7(0):'get trailing OCR
310 U=USR3(0)
320 T=0
330 IF T=16 THEN PRINT:PRINT"Card does not become ready":STOP
340 ' ### sending CMD55 ###
350 PRINT".";:C$="7700000000":GOSUB 1700:U=USR6(0):U=USR1(0):GOSUB 1650
360 ' ### sending ACMD41 ###
370 PRINT".";:C$="6940000000":GOSUB 1700:U=USR6(0):U=USR1(0):GOSUB 1650
380 IF (S AND 1)=1 THEN T=T+1:GOTO 330
390 PRINT"Success"
400 ' ### sending CMD58 ###
410 PRINT"Getting information":C$="7A00000000":GOSUB 1700:U=USR6(0):U=USR1(0):GOSUB 1670
420 ' -- Geting OCR --
430 PRINT"  > OCR = ";
440 L=4:POKE MA+8,(L AND &HFF):POKE MA+9,L/256:U=USR7(0):U=USR3(0)
450 FOR I=0 TO 3:S=PEEK(H+I):GOSUB 1860:NEXT I
460 PRINT:PRINT"  > ";:IF (PEEK(H) AND &H40)<>0 THEN PRINT"Block";:BM=1 ELSE PRINT"Byte";:BM=0
470 PRINT" addressing mode":PRINT"  > 3v3 mode is ";:A=(PEEK(H+1) AND &H30)
480 IF A=0 THEN PRINT"not";
490 PRINT" suppoted":IF A=0 THEN STOP
500 ' ### sending CMD10 ###
510 C$="4A00000000":GOSUB 1700:U=USR6(0):U=USR1(0):GOSUB 1670
520 ' -- Geting CID --
530 L=16:POKE MA+8,(L AND &HFF):POKE MA+9,L/256:U=USR5(0)
540 U=USR3(0)
550 PRINT"  > MID = ";:S=PEEK(H):GOSUB 1860:PRINT", OID = ";:FOR I=1 TO 2:PRINTCHR$(PEEK(H+I));:NEXT I
560 PRINT", PNM = ";:FOR I=3 TO 7:PRINTCHR$(PEEK(H+I));:NEXT I:PRINT
570 M=(PEEK(H+14) AND &HF):Y=2000+(PEEK(H+13) AND &H15)*16+FIX(PEEK(H+14)/16)
580 PRINT"  > MDT =";STR$(Y);"/";CHR$(&H30+FIX(M/10));CHR$(&H30+(M MOD 10));
590 PRINT", SN = ";:FOR I=9 TO 12:S=PEEK(H+I):GOSUB 1860:NEXT I
600 PRINT
610 ' ### sending CMD16 ###
620 C$="5000000200":GOSUB 1700:U=USR6(0):U=USR1(0):GOSUB 1650
630 ' ### sending CMD17 ###
640 PRINT"Reading MBR... ";
650 C$="5100000000":GOSUB 1700:U=USR6(0):U=USR1(0):GOSUB 1670:L=512:GOSUB 1770:U=USR3(0)
660 IF PEEK(H+510)=&H55 AND PEEK(H+511)=&HAA THEN PRINT"valid" ELSE PRINT"invalid":STOP
670 PRINT" #  Type  Start     Length":O=&H1BE:F=0
680 FOR I=0 TO 3
690 S=PEEK(H+O+4):IF S=0 THEN 730
700 F=F+1:PRINT I;" ";:GOSUB 1860:PRINT"    ";
710 FOR J=0 TO 3:S=PEEK(H+O+11-J):GOSUB 1860:NEXT J:PRINT"  ";
720 FOR J=0 TO 3:S=PEEK(H+O+15-J):GOSUB 1860:NEXT J:PRINT
730 O=O+16
740 NEXT I
750 IF F=0 THEN PRINT"  > No partitions found":STOP
760 IF F=1 THEN C=&H30:GOTO 790
770 PRINT "  > ";F;"partitions found":PRINT "Select partition: ";
780 A$=INPUT$(1):C=ASC(A$):IF C<&H30 OR C>F+&H2F THEN GOTO 780
790 C=C-&H30
800 PRINT"Partition is ";
810 IF PEEK(H+&H1BE+C*16+4)=6 THEN PRINT"supported" ELSE PRINT"not supported":STOP
820 ' ### Reading boot sector (CMD17) ###
830 PRINT"Getting config... ";
840 'BO boot sector sector#
850 BO=PEEK(H+&H1BE+C*16+8)+PEEK(H+&H1BE+C*16+9)*256+PEEK(H+&H1BE+C*16+10)*65536!+PEEK(H+&H1BE+C*16+11)*16777216#
860 AR=BO:GOSUB 1530:U=USR1(0):GOSUB 1670:L=512:GOSUB 1770:U=USR3(0)
870 FE=0:'0=FAT32 standard mode
880 ' ### Getting volume configuration ###
890 ' !!! does not count hidden sectors !!!
900 'BS=bytes per sector, SC=sectors per cluster, NF=num of FATs
910 'DE=dir entries, FS=sectors per FAT, RS=reserved sectors, MI=media ID
920 IF PEEK(H)<>&HEB OR PEEK(H+2)<>&H90 THEN PRINT"invalid":STOP ELSE PRINT"valid"
930 PRINT"SecSize = ";:S=PEEK(H+12):BS=S*256:GOSUB 1860:S=PEEK(H+11):BS=BS+S:GOSUB 1860
940 PRINTCHR$(9);"SecClu = ";:S=PEEK(H+13):SC=S:GOSUB 1860:PRINT
950 PRINT"FATs =    ";:S=PEEK(H+16):NF=S:GOSUB 1860
960 PRINTCHR$(9);"DirEnt = ";:S=PEEK(H+18):DE=S*256:GOSUB 1860:S=PEEK(H+17):DE=DE+S:GOSUB 1860:PRINT
970 PRINT"SecFAT =  ";:S=PEEK(H+23):FS=S*256:GOSUB 1860:S=PEEK(H+22):FS=FS+S:GOSUB 1860
980 PRINTCHR$(9);"ResSec = ";:S=PEEK(H+15):RS=S*256:GOSUB 1860:S=PEEK(H+14):RS=RS+S:GOSUB 1860:PRINT
990 PRINT"MediaID = ";:S=PEEK(H+21):MI=S:GOSUB 1860:PRINT
1000 IF BS<>512 OR SC=0 OR SC>64 OR NF<>2 THEN PRINT"FS is not supported":STOP:'sector should be 512 bytes
1010 IF DE=0 OR FS=0 THEN PRINT"  > FAT32 EBPB detected" ELSE PRINT"  > FAT32 not detected":STOP
1020 'FAT32 EBPB processing: FS=sectors per FAT, DF=root dir cluster#
1030 FE=1:FS=PEEK(H+&H27)*16777216#+PEEK(H+&H26)*65536!+PEEK(H+&H25)*256+PEEK(H+&H24)
1040 DF=PEEK(H+&H2F)*16777216#+PEEK(H+&H2E)*65536!+PEEK(H+&H2D)*256+PEEK(H+&H2C)
1050 PRINT"SecFat = ";:AR=FS:GOSUB 1490:PRINT"  DirClu = ";:AR=DF:GOSUB 1490:PRINT
1060 FO=BO+RS:CO=FO+FS*2:'FO=first FAT sector#, CO=cluster 2 sector#
1070 PRINT"FAToff = ";:AR=FO:GOSUB 1490:PRINT"  CL2off = ";:AR=CO:GOSUB 1490:PRINT
1080 DD=0:DH(0)=DF:'initialize dir hierarchy
1090 ' ### Displaying the menu ###
1100 PRINT" ":PRINT"1. DIR";CHR$(9);CHR$(9);"2. Download file"
1110 PRINT"3. CHDIR";CHR$(9);"4. Display sector":PRINT"5. Exit":PRINT"> ";
1120 A$=INPUT$(1):A=ASC(A$):IF A<&H31 OR A>&H35 THEN 1120
1130 PRINT CHR$(A):A=A-&H30
1140 N$="":GOSUB 3030:'build current directory cluster chain
1150 ON A GOTO 1170,1250,1190,1360,1160
1160 STOP
1170 ' ### Display directory contents ###
1180 GOSUB 2700:GOTO 1100:'display directory contents
1190 ' ### Change directory ###
1200 NM$="":INPUT"Name";NM$:IF NM$="" THEN 1100
1210 IF NM$="." THEN DD=0:GOTO 1100:'go to root dir
1220 IF NM$=".." THEN IF DD>0 THEN DD=DD-1:GOTO 1100 ELSE PRINT"Already at root level":GOTO 1100
1230 GOSUB 3510:GOSUB 2700:IF FC=0 THEN PRINT"Directory not found":GOTO 1100
1240 GOSUB 3200:DD=DD+1:DH(DD)=FC:DN$(DD)=NM$:GOTO 1100:'next dir level
1250 ' ### Download the file ###
1260 AD=PEEK(&HF347):IF AD=0 THEN PRINT"No target devices present":GOTO 1100
1270 NM$="":INPUT"Name";NM$:IF NM$="" THEN 1100
1280 GOSUB 3510:GOSUB 2700:IF FC=0 THEN PRINT"File not found":GOTO 1100 ELSE GOSUB 3200
1290 PRINT"Destination drive (or ESC) ";
1300 A$=INPUT$(1):S=ASC(A$):IF S=27 THEN 1100 ELSE S=(S AND &HDF)-&H41:IF S>=AD THEN 1300
1310 DR$=CHR$(S+&H41):PRINT DR$;":"
1320 DD=DD+1:DH(DD)=FC:GOSUB 3030:'go to next depth level, and build cluster chain for file
1330 PRINT"Occupies";DC;"clusters":IF SI=0 OR DC=0 THEN PRINT"Unable to copy":GOTO 1350
1340 GOSUB 3230:'copy the file
1350 DD=DD-1:GOTO 1100:'back to prev hierarchy level
1360 ' ### Display sector contents ###
1370 A$="":INPUT"Sector# (decimal)";A$:IF A$="" THEN 1100
1380 AR=VAL(A$):GOSUB 1530:U=USR1(0):GOSUB 1670:L=512:GOSUB 1770:U=USR3(0)
1390 S=PEEK(&HF3B0):IF S<70 THEN S=8 ELSE S=16:'number of bytes per row
1400 A=0:DS=0
1410 S$=HEX$(A):S$=STRING$(3-LEN(S$),"0")+S$:PRINT S$;": ";
1420 FOR I=0 TO S-1:S$=HEX$(PEEK(H+A+I)):S$=STRING$(2-LEN(S$),"0")+S$+" ":PRINT S$;:NEXT I
1430 FOR I=0 TO S-1:C=PEEK(H+A+I):IF C<32 OR C=127 THEN PRINT"."; ELSE PRINTCHR$(C);
1440 NEXT I
1450 A=A+S:PRINT
1460 DS=DS+1:IF DS=16 AND A<512 THEN DS=0:PRINT"Press SPACE to continue":A$=INPUT$(1):IF A$<>" " THEN 1480 ELSE PRINT
1470 IF A<512 THEN 1410
1480 GOTO 1100
1490 ' **** Print number in 32-bit format **** arg is in AR
1500 S=FIX(AR/16777216#):GOSUB 1860:AR=AR-S*16777216#:S=FIX(AR/65536!):GOSUB 1860
1510 AR=AR-S*65536!:S=FIX(AR/256):GOSUB 1860:S=AR-S*256:GOSUB 1860
1520 RETURN
1530 ' **** Put sector number into read command ****, input sector # is in AR
1540 POKE MA,&H51
1550 IF BM=0 THEN 1600
1560 'Block addressing mode
1570 T0=AR:S=FIX(T0/16777216#):POKE MA+1,S:T0=T0-S*16777216#:S=FIX(T0/65536!)
1580 POKE MA+2,S:T0=T0-S*65536!:S=FIX(T0/256):POKE MA+3,S:S=T0-S*256:POKE MA+4,S
1590 GOTO 1640
1600 'Byte addressing mode
1610 POKE MA+4,0:'sector # mult 512
1620 T0=AR*2:T2=FIX(T0/65536!):T0=T0-T2*65536!:T1=FIX(T0/256):T0=T0-T1*256
1630 POKE MA+3,T0:POKE MA+2,T1:POKE MA+1,T2
1640 U=USR6(0):RETURN
1650 ' **** Get R1 type response only ****
1660 GOSUB 1670:U=USR3(0):RETURN
1670 ' **** Get R1 type response ****
1680 U=USR2(0):S=PEEK(MA+6):IF (S AND &HFE)<>0 THEN PRINT"@CMDERR: ";:GOSUB 1860
1690 RETURN
1700 ' **** Convert string (C$) to command ****
1710 FOR I=0 TO 4
1720 C=ASC(MID$(C$,I*2+1,1)):IF C>&H40 THEN S=(C-&H37)*16 ELSE S=(C-&H30)*16
1730 C=ASC(MID$(C$,I*2+2,1)):IF C>&H40 THEN S=S+C-&H37 ELSE S=S+C-&H30
1740 POKE MA+I,S
1750 NEXT I
1760 RETURN
1770 ' **** Data transfer ****
1780 ' Waiting for token
1790 POKE MA+8,(L AND &HFF):POKE MA+9,L/256
1800 U=USR5(0):S=PEEK(MA+6)
1810 IF S=&HFE THEN GOTO 1850
1820 IF (S AND &HF0)=0 THEN PRINT"Error token: ";HEX$(S):STOP
1830 IF S<>&HFF THEN PRINT"Unknown token error: ";HEX$(S):STOP
1840 PRINT"Response timeout":STOP
1850 RETURN
1860 ' **** Prints HEX of S in 2 pos ****
1870 S$=HEX$(S):IF LEN(S$)=1 THEN PRINT"0";
1880 PRINTS$;:RETURN
1890 ' ### Assembler routines ###
1900 '+000...+005 = command, +006 = R1 response byte
1910 '+008...+009 = datatransfer length, +00A...+00B =CRC16
1920 ' -- Send command routine, start addr +010h --
1930 DATA &h3E,4,&hD3,&hAC,&h21,0,&hc0,6,6,&hc5,&h4e,&h16,&h80
1940 DATA 6,8,&h79,&h1e,4,&ha2,&h20,2,&h1e,0,&h7b,&hd3,&hac
1950 DATA &h3c,&hd3,&hac,&hcb,&h3a,&h10,&hee,&hc1,&h23,&h10,&he4,&hc9
1960 DATA 0,0,0,0,0,0,0,0,0,0:'spare bytes
1970 ' -- Get byte from the stream, start address +040h --
1980 DATA &h11,0,&h80,6,8,&h3e,4,&hd3,&hac,&h3c,&hd3,&hac,&hdb,&hac
1990 DATA &he6,1,&h28,3,&h7b,&h82,&h5f,&hcb,&h3a,&h10,&hec,&hc9
2000 DATA 0,0,0,0,0,0:'spare bytes
2010 '-- Get token and save to 0c006h, address +060h --
2020 DATA &hcd,&h40,&hc0,&h7b,&h32,6,&hc0,&hc9
2030 DATA 0,0,0,0,0,0,0,0:'spare bytes
2040 ' -- Get R1 response routine, start address +070h --
2050 DATA &h21,0,2,&hcd,&h60,&hc0,&he6,&h80
2060 DATA &h28,5,&h2b,&h7c,&hb5,&h20,&hf4,&hc9
2070 DATA 0,0,0,0,0,0,0,0:'spare bytes
2080 '-- 8 SCLK after command, start address +088h --
2090 DATA 6,8,&h3e,4,&hd3,&hac,&h3c,&hd3,&hac,&h3d,&h10,&hf8
2100 DATA &hd3,&hac,&h3e,6,&hd3,&hac,&hc9
2110 DATA 0,0,0,0,0:'spare bytes
2120 ' -- 75 spare cycles, start address +0A0h --
2130 DATA 6,&h4b,&hcd,&h8a,&hc0,&hc9
2140 DATA 0,0,0,0,0,0,0,0,0,0:'spare bytes
2150 ' -- Read data transfer with token, size in +008h, CRC16 will be in +00Ah, start +0B0h --
2160 DATA &h21,0,2,&hcd,&h60,&hc0,&hfe,&hfe,&h28,9,&hfe,&hff,&hc0
2170 DATA &h2b,&h7c,&hb5,&h20,&hf1,&hc9,&hcd,&hd8,&hc0,&hcd,&h40,&hc0,&h6f
2180 DATA &hcd,&h40,&hc0,&h67,&h22,&h0a,&hc0,&hc9
2190 DATA 0,0,0,0,0,0:'spare bytes
2200 ' -- Read data, size in +008h, no token, no CRC, addr +0D8h
2210 DATA &hed,&h4b,8,&hc0,&h2a,&h4d,&hf3,&hc5,&hcd,&h40,&hc0,&h73
2220 DATA &h23,&hc1,&hb,&h78,&hb1,&h20,&hf4,&hc9
2230 DATA 0,0,0,0:'spare bytes
2240 '-- Calculate CRC7 for command, place it to +005h, address +0F0h --
2250 DATA &h21,0,&hc0,&haf,6,5,&h4e,&hc5,6,8,&hcb,&h27,&hf5,&ha9
2260 DATA &h11,1,8,&he6,&h80,&h20,&h03,&h11,0,0,&hf1,&haa,&h83
2270 DATA &hcb,&h21,&h10,&heb,&hc1,&h23,&h10,&he3,7,&hf6,1,&h32,5,&hc0,&hc9
2280 DATA 0,0,0,0,0,0:'spare bytes
2290 '-- Save chunk of file, address +120h --
2300 DATA &h2a,&h3d,&hf2,&he5,&h2a,&h4d,&hf3,&h22,&h3d,&hf2
2310 DATA &h11,&h58,&hc1,&h21,0,0,&h0e,&h26,&hcd,&h7d,&hf3
2320 DATA &he1,&h22,&h3d,&hf2,&h32,&h6,&hc0,&hc9
2330 DATA 0,0,0,0,0,0,0:'spare bytes
2340 '-- Open/Close file, address +144h; set function# before calling --
2350 DATA &h11,&h58,&hc1,&he,0,&hcd,&h7d,&hf3,&h32,6,&hc0,&hc9
2360 DATA 0,0,0,0,0,0,0,0:'spare bytes
2370 '-- FCB area, address +158h --
2380 DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
2390 DATA &hc9:'stream end ID
2400 FOR I=0 TO 15:POKE MA+I,0:NEXT I
2410 FOR I=0 TO 48+32+16+24+24+16+40+24+48+36+20+37:READ A:POKE MA+16+I,A:NEXT I
2420 DEFUSR1=MA+&H10:'Send command routine
2430 DEFUSR2=MA+&H70:'Get R1 type response
2440 DEFUSR3=MA+&H88:'Issue 8 SCLK after command
2450 DEFUSR4=MA+&HA0:'Issue 75 spare cycles
2460 DEFUSR5=MA+&HB0:'Read data/token/CRC
2470 DEFUSR6=MA+&HF0:'Calculate CRC7 for command
2480 DEFUSR7=MA+&HD8:'Read data/no token/no CRC
2490 DEFUSR8=MA+&H120:SA=MA+&H12E:'Save chunk of data to disk, number of recs in 0c12eh
2500 DEFUSR9=MA+&H144:SU=MA+&H148:FB=MA+&H158:'Open/Close file
2510 'altering addresses in assembly code
2520 DATA &h15,0,&h61,&h40,&h65,6,&h74,&h60,&ha3,&h8a,&hb4,&h60,&hc4,&hd8
2530 DATA &hc7,&h40,&hcb,&h40,&hcf,10,&hda,8,&he1,&h40,&hf1,0,&h117,5
2540 DATA &h12b,&h158,&h13a,6,&h145,&h158,&h14d,6
2550 RESTORE 2520
2560 FOR I=1 TO 18:READ T0,T1:T2=FIX((MA+T1)/256):POKE MA+T0+1,T2:POKE MA+T0,MA+T1-T2*256:NEXT I
2570 RETURN
2580 FOR I0=0 TO 15
2590 FOR I1=0 TO 15
2600 S$=HEX$(PEEK(H+I1+I0*16)):IF LEN(S$)=1 THEN PRINT"0";
2610 PRINTS$;" ";
2620 NEXT I1
2630 PRINT"  ";
2640 FOR I1=0 TO 15:I2=PEEK(H+I1+I0*16)
2650 IF I2<32 OR I2=127 OR I2>240 THEN PRINT"."; ELSE PRINTCHR$(I2);
2660 NEXT I1
2670 PRINT
2680 NEXT I0
2690 RETURN
2700 ' **** Read and scan dir for name in N$, if N$="" then display dir ****
2710 'if N$<>"", return FC=file first cluster, SI=file size in bytes
2720 PRINT"Path: /";
2730 IF DD>0 THEN FOR I=1 TO DD:PRINTDN$(I);"/";:NEXT I
2740 PRINT:DS=0:'line display counter
2750 FOR I=0 TO DC-1
2760 SE=(DC(I)-2)*SC+CO
2770 FOR J=1 TO SC
2780 AR=SE:GOSUB 1530:U=USR1(0):GOSUB 1670:L=512:GOSUB 1770:U=USR3(0)
2790 FOR K=0 TO 480 STEP 32:'16 dir entries
2800 GOSUB 3460:'display progress indicator
2810 A=PEEK(H+K):IF A=&HE5 OR A=0 THEN 2970:'unused entries
2820 A=PEEK(H+K+11):IF A=15 THEN2970:'long fname
2830 NA$="":DN$="":FOR L=0 TO 10:C=PEEK(H+K+L):IF C>&H60 AND C<&H7B THEN C=(C AND &HDF):'toupper
2840 IF L=8 THEN DN$=DN$+" ":'DN$ is display name
2850 NA$=NA$+CHR$(C):DN$=DN$+CHR$(C):NEXT L
2860 IF N$<>"" AND NA$<>N$ THEN 2920
2870 PRINT DN$;
2880 SI=PEEK(H+K+&H1C)+PEEK(H+K+&H1D)*256+PEEK(H+K+&H1E)*65536!+PEEK(H+K+&H1F)*16777216#
2890 FC=PEEK(H+K+&H1A)+PEEK(H+K+&H1B)*256+PEEK(H+K+&H14)*65536!+PEEK(H+K+&H15)*16777216#
2900 IF (A AND 16)<>0 THEN PRINT" <DIR>" ELSE PRINTUSING"##########,";SI
2910 DS=DS+1
2920 IF NA$=N$ THEN 3010:'N$ file was found
2930 IF DS<16 THEN 2970
2940 PRINT"Press SPACE to continue":DS=0
2950 IF INKEY$<>"" THEN 2950:'clear kbd buffer
2960 A$=INPUT$(1):IF A$<>" " THEN 3010 ELSE PRINT
2970 NEXT K
2980 SE=SE+1
2990 NEXT J
3000 NEXT I
3010 IF N$<>"" AND NA$<>N$ THEN SI=0:FC=0:'file not found
3020 RETURN
3030 ' **** Build cluster chain ****
3040 'input: DD=dir depth level, DH()=dir hierarchy start clusters array, FO=first FAT sector#
3050 'output: DC(0-...)=cluster chain, DC(0)=start cluster, DC=number of clusters
3060 'corrupt: CF=current FAT sector#, CL=entry# in FAT sector
3070 DC=1:DC(0)=DH(DD)
3080 'reading respective FAT sector
3090 CF=FIX(DC(DC-1)/128):'FAT sector# to read
3100 AR=FO+CF:GOSUB 1530:U=USR1(0):GOSUB 1670:L=512:GOSUB 1770:U=USR3(0)
3110 'getting next cluster#
3120 CL=DC(DC-1)-CF*128:'next cluster# offset in FAT
3130 DC(DC)=PEEK(H+CL*4+3)*16777216#+PEEK(H+CL*4+2)*65536!+PEEK(H+CL*4+1)*256+PEEK(H+CL*4)
3140 'checking for last cluster in chain
3150 IF DC(DC)=268435455# THEN 3190
3160 'deciding if to load new FAT sector
3170 GOSUB 3460:'display progress indicator
3180 DC=DC+1:IF FIX(DC(DC-1)/128)=CF THEN 3120 ELSE 3090
3190 RETURN
3200 ' **** Display file/dir start cluster and cluster count ****
3210 PRINT"Cluster = ";:AR=FC:GOSUB 1490:PRINT"  Size = ";:AR=SI:GOSUB 1490:PRINT
3220 RETURN
3230 ' **** Copy the file ****
3240 'input: DC()=cluster chain, DC=number of clusters, SI=file size
3250 'input: DR$=target drive name. N$=file name
3260 FOR I=0 TO 36:POKE FB+I,0:NEXT I:'clear FCB
3270 POKE FB,ASC(DR$)-&H40:FOR I=1 TO LEN(N$):POKE(FB+I),ASC(MID$(N$,I,1)):NEXT I
3280 POKE SU,&H16:U=USR9(0):'create the file
3290 IF PEEK(MA+6)<>0 THEN PRINT"Creation error":GOTO 3450
3300 POKE FB+14,1:POKE FB+15,0:'record size=1
3310 SZ=SI:'countdown size
3320 FOR I=1 TO DC:'per cluster
3330 FOR J=1 TO SC:'per sector
3340 IF SZ>512 THEN LE=512 ELSE LE=SZ
3350 IF SZ=0 THEN 3430
3360 AR=CO+(DC(I-1)-2)*SC+J-1:GOSUB 1530:U=USR1(0):GOSUB 1670:L=512:GOSUB 1770:U=USR3(0)
3370 POKE SA,LE AND 255:POKE SA+1,FIX(LE/256):U=USR8(0):'write sector
3380 IF PEEK(MA+6)<>0 THEN PRINT"Write error":GOTO 3440
3390 SZ=SZ-LE
3400 NEXT J
3410 PRINTUSING"###%";(SI-SZ)/SI*100;:PRINTCHR$(13);
3420 NEXT I
3430 PRINT"Complete"
3440 POKE SU,&H10:U=USR9(0):'close the file
3450 RETURN
3460 ' **** Show that operation is in progress ****
3470 IF PR>3 THEN PR=0
3480 IF PR=0 THEN PR$="|" ELSE IF PR=1 THEN PR$="/" ELSE IF PR=2 THEN PR$="-" ELSE IF PR=3 THEN PR$="\"
3490 PR=PR+1:PRINT PR$;CHR$(13);
3500 RETURN
3510 ' **** Convert X.X file name to 8:3 DIR format ****
3520 'input: NM$=X.X file name, output N$=8:3 file name
3530 'corrupt: EX,S,A$,C
3540 N$="":S=LEN(NM$):EX=0:'EX=processing extension flag
3550 FOR I0=1 TO S
3560 A$=MID$(NM$,I0,1)
3570 C=ASC(A$):IF C>&H60 AND C<&H7B THEN A$=CHR$(C AND &HDF):'toupper
3580 IF LEN(N$)=8 AND EX=0 AND A$<>"." THEN 3610:'skip name if longer than 8 chars
3590 IF LEN(N$)=11 AND EX=1 THEN 3610:'skip extension if longer than 3
3600 IF A$="." THEN N$=N$+SPACE$(8-LEN(N$)):EX=1 ELSE N$=N$+A$
3610 NEXT I0
3620 N$=N$+SPACE$(11-LEN(N$))
3630 RETURN
